import { IEvent, ITerminalOptions, Terminal as XTermTerminal } from 'xterm';
import { XTermTerminalWriteData } from '@pugio/types';
export * from 'xterm';
export declare class Terminal<T extends Record<string, any>> extends XTermTerminal {
    onSequenceData: IEvent<string, any>;
    protected data: T;
    private sendSequence;
    private writeSequence;
    private initializingContent;
    constructor(options?: ITerminalOptions);
    initialize(contentList: string[] | Uint8Array[], dataParser?: (rawContent: string | Uint8Array) => string, callback?: () => void): void;
    sequenceWrite(data: XTermTerminalWriteData, dataParser?: (rawContent: string | Uint8Array) => string, callback?: () => void): void;
    private handleSequenceData;
}
