"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Terminal = void 0;
const xterm_1 = require("xterm");
const _ = __importStar(require("lodash"));
__exportStar(require("xterm"), exports);
class Terminal extends xterm_1.Terminal {
    constructor(options) {
        super(options);
        this.sendSequence = 0;
        this.writeSequence = 0;
        this.initializingContent = true;
        this.onSequenceData = (listener) => {
            return this.onData.call(this, async (arg1, arg2) => {
                return await this.handleSequenceData(arg1, arg2, listener);
            });
        };
    }
    initialize(contentList, dataParser, callback) {
        const parseData = _.isFunction(dataParser) ? dataParser : (data) => data;
        if (_.isArray(contentList) && contentList.length > 0) {
            for (const contentListItem of contentList) {
                if (contentListItem) {
                    const content = parseData(contentListItem);
                    xterm_1.Terminal.prototype.write.call(this, content);
                }
            }
        }
        this.initializingContent = false;
        if (_.isFunction(callback)) {
            callback.call(this);
        }
    }
    sequenceWrite(data, dataParser, callback) {
        const { content: rawContent, sequence } = data;
        const parseData = _.isFunction(dataParser) ? dataParser : (data) => data;
        const intervalId = setInterval(() => {
            if (!this.initializingContent && this.writeSequence + 1 === sequence) {
                const content = parseData(rawContent);
                xterm_1.Terminal.prototype.write.call(this, content, callback);
                this.writeSequence = sequence;
                clearInterval(intervalId);
            }
        }, 0);
    }
    async handleSequenceData(arg1, arg2, callback) {
        if (!_.isFunction(callback)) {
            return;
        }
        while (this.initializingContent) {
            continue;
        }
        const callbackFunction = callback.bind(this);
        this.sendSequence += 1;
        await callbackFunction({
            sequence: this.sendSequence,
            content: arg1,
        }, arg2);
    }
}
exports.Terminal = Terminal;
